/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014,2015 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */

/*
 *  VAI/OfoCXiSIOjhCo
 */

#ifndef TOPPERS_TARGET_SERIAL_H
#define TOPPERS_TARGET_SERIAL_H

#include "qb_r5f100le.h"
#include "target_syssvc.h"

#define	TBIT_ENACB_RCV	UINT8_C(0x02)	/* MR[obN */
#define	TBIT_ENACB_SND	UINT8_C(0x01)	/* MR[obN */

/*
 *  e|[gɑΉ銄ݔԍCDx
 */
/* |[g1 */
// ݔԍ
#define INTNO_SIOP1_SND	INTNO_INTST0
#define INTNO_SIOP1_RCV	INTNO_INTSR0

// ݗDx
#define INTPRI_SIOP1_SND	(-1)	
#define INTPRI_SIOP1_RCV	(-2)

// ݗvC
#define INTATR_SIOP1_RCV  	(0)
#define INTATR_SIOP1_SND  	(0)

/*
 *  R[obN[`̎ʔԍ
 */
#define SIO_RDY_SND    1U        /* M\R[obN */
#define SIO_RDY_RCV    2U        /* MʒmR[obN */

#ifndef TOPPERS_MACRO_ONLY

/*
 *  VAI/O|[gǗubN
 */
typedef struct sio_port_control_block {
	intptr_t      	exinf;    	/* g */
	uint8_t       	enacb;      /* R[obNۂ̏ */
};

/*
 *  VAI/O|[gǗubN̒`
 */
typedef struct sio_port_control_block	SIOPCB;

/*
 *  SIO
 */
extern void sio_initialize(intptr_t exinf);

/*
 * ჌xVA
 */
extern void target_sau_init(ID siopid);

/*
 *  VAI[v
 */
extern SIOPCB *sio_opn_por(ID siopid, intptr_t exinf);

/*
 *  VAN[Y
 */
extern void sio_cls_por(SIOPCB *p_siopcb);

/*
 *  ݃T[rX[`
 */
extern void sio_isr_rcv(intptr_t exinf);
extern void sio_isr_snd(intptr_t exinf);

/*
 *  1M
 */
extern bool_t sio_snd_chr(SIOPCB *siopcb, char c);

/*
 *  1M
 */
extern int_t sio_rcv_chr(SIOPCB *siopcb);

/*
 *  R[obN̋
 */
extern void sio_ena_cbr(SIOPCB *siopcb, uint_t cbrtn);

/* 
 *  R[obN̋֎~
 */
extern void sio_dis_cbr(SIOPCB *siopcb, uint_t cbrtn);

/*
 *  M\R[obN
 */
extern void sio_irdy_snd(intptr_t exinf);

/*
 *  MʒmR[obN
 */
extern void sio_irdy_rcv(intptr_t exinf);

/*
 *  1Mi|[Oł̏ój
 */
extern void sio_pol_snd_chr(char c, ID siopid);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_TARGET_SERIAL_H */
